"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Player = void 0;
const Tools_1 = require("./Tools");
class Player {
    constructor(data, map, g) {
        this.armor = 0;
        this.apiercing = 0;
        this.avoidance = 0;
        this.crit = 0;
        this.critdamage = 0;
        this.evasion = 0;
        this.level = 1;
        this.reflection = 0;
        this.resistance = 0;
        this.rpiercing = 0;
        this.s = {};
        this.c = {};
        this.q = {};
        this.G = g;
        this.map = map;
        if (!data.npc)
            this.damage_type = this.G.classes[data.ctype].damage_type;
        this.updateData(data);
    }
    updateData(data) {
        if (this.id !== undefined && this.id !== data.id)
            throw Error("The entity's ID does not match");
        for (const key in data)
            this[key] = data[key];
    }
    calculateDamageRange(defender, skill = "attack") {
        if (defender["1hp"])
            return [1, 1];
        let baseDamage = this.attack;
        if (this.G.skills[skill].damage)
            baseDamage = this.G.skills[skill].damage;
        if (defender.s.cursed)
            baseDamage *= 1.2;
        if (defender.s.marked)
            baseDamage *= 1.1;
        if (this.ctype == "priest")
            baseDamage *= 0.4;
        let additonalApiercing = 0;
        if (this.G.skills[skill].apiercing)
            additonalApiercing = this.G.skills[skill].apiercing;
        if (this.damage_type == "physical")
            baseDamage *= Tools_1.Tools.damage_multiplier(defender.armor - this.apiercing - additonalApiercing);
        else if (this.damage_type == "magical")
            baseDamage *= Tools_1.Tools.damage_multiplier(defender.resistance - this.rpiercing);
        if (this.G.skills[skill].damage_multiplier)
            baseDamage *= this.G.skills[skill].damage_multiplier;
        if (this.crit) {
            if (this.crit >= 100) {
                return [baseDamage * 0.9 * (2 + (this.critdamage / 100)), baseDamage * 1.1 * (2 + (this.critdamage / 100))];
            }
            else {
                return [baseDamage * 0.9, baseDamage * 1.1 * (2 + (this.critdamage / 100))];
            }
        }
        else {
            return [baseDamage * 0.9, baseDamage * 1.1];
        }
    }
    isFriendly(bot) {
        if (bot.owner == this.owner)
            return true;
        if (bot.party == this.party)
            return true;
        return false;
    }
    isNPC() {
        return this.npc !== undefined;
    }
}
exports.Player = Player;
//# sourceMappingURL=Player.js.map